/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.petra.sql.dsl;

import com.liferay.petra.sql.dsl.ast.ASTNode;

import java.util.Collection;

/**
 * @author Preston Crary
 */
public interface Table<T extends Table<T>> extends ASTNode {

	public T as(String alias);

	public Column<T, ?> getColumn(String name);

	public <C> Column<T, C> getColumn(String name, Class<C> clazz);

	public Collection<Column<T, ?>> getColumns();

	public String getName();

	public String getTableName();

}