/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.petra.sql.dsl.ast;

import com.liferay.petra.string.StringBundler;

import java.util.function.Consumer;

/**
 * @author Preston Crary
 */
public interface ASTNode {

	public default String toSQL(ASTNodeListener astNodeListener) {
		StringBundler sb = new StringBundler();

		toSQL(sb::append, astNodeListener);

		return sb.toString();
	}

	public void toSQL(
		Consumer<String> consumer, ASTNodeListener astNodeListener);

}