/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.petra.sql.dsl.factory;

import com.liferay.petra.sql.dsl.Table;
import com.liferay.petra.sql.dsl.expression.Expression;
import com.liferay.petra.sql.dsl.query.FromStep;

/**
 * @author Preston Crary
 */
public interface DSLQueryFactory {

	public FromStep count();

	public FromStep countDistinct(Expression<?> expression);

	public FromStep select();

	public FromStep select(Expression<?>... expressions);

	public <T extends Table<T>> FromStep select(Table<T> table);

	public FromStep selectDistinct(Expression<?>... expressions);

	public <T extends Table<T>> FromStep selectDistinct(T table);

}