/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.petra.sql.dsl.query;

import com.liferay.petra.sql.dsl.Table;
import com.liferay.petra.sql.dsl.query.sort.OrderByExpression;
import com.liferay.petra.sql.dsl.query.sort.OrderByInfo;

import java.util.function.Function;

/**
 * @author Preston Crary
 */
public interface OrderByStep extends LimitStep {

	public default LimitStep orderBy(
		Function<OrderByStep, LimitStep> function) {

		LimitStep limitStep = function.apply(this);

		if (limitStep == null) {
			return this;
		}

		return limitStep;
	}

	public LimitStep orderBy(OrderByExpression... orderByExpressions);

	public LimitStep orderBy(Table<?> table, OrderByInfo orderByInfo);

}